local version = "5.1.6";
-- the guild achievement ID
LoadAddOn("Blizzard_MacroUI")
-- GetSpellorMacroIconInfo now exists
local critterTrackId = 5144;
-- how often it's displayed to the guild
local defaultReportFrequency = 25;
--local SCK_icon
--local SCK_guildspam
--local SCK_selfspam
--local SCK_zonespam
if SCK_icon == nil then
	SCK_icon = "ability_druid_cower"
end
if SCK_guildspam == nil then
	SCK_guildspam = "on"
end
if SCK_selfspam == nil then
	SCK_selfspam = "on"
end
if SCK_zonespam == nil then
	SCK_zonespam = "on"
end
local L_CRITTER = "Critter";
--local SCK_guildspam, SCK_selfspam, SCK_zonespam = true, true, true
-- if SCK_guildspam == nil then
	-- SCK_guildspam, SCK_selfspam, SCK_zonespam = true, true, true
-- end
-- critters by zone
local Critters = {
--Kalimdor
["Ahn'Qiraj: The Fallen Kingdom"]={"Scarab Hatchling", "Sidewinder"},
["Ammen Vale"]={"Grey Moth"},
["Ashenvale"]={"Deer", "Forest Moth", "Frog", "Maggot", "Rat", "Roach", "School of Fish"},
["Azshara"]={"Rabbit", "Rabid Nut Varmint 5000", "Rat", "Roach", "Robo-Chick", "Shore Crab", "Skunk", "Spider"},
["Azuremyst Isle"]={"Chicken", "Skunk"},
["Bloodmyst Isle"]={""},
["Camp Narache"]={"Prairie Dog"},
["Darkshore"]={"Corrupted Duskrat", "Deer", "Mottled Doe", "Rabbit", "Rat", "School of Fish", "Sickly Deer", "Squirrel"},
["Darnassus"]={"Deer", "Elfin Rabbit", "Forest Moth", "Red-Tailed Chipmunk", "Small Frog", "Squirrel", "Toad"},
["Desolace"]={"Desert Spider", "Elfin Rabbit", "Forest Moth", "Gazelle", "Hairy Armadillo", "Horny Toad", "Prairie Dog", "Rabbit", "Rat", "Red-Tailed Chipmunk", "Roach", "Rock Viper"},
["Durotar"]={"Adder", "Dung Beetle", "Hare", "Moccasin", "School of Fish", "Spiny Lizard", "Swine"},
["Dustwallow Marsh"]={"Black Rat", "Chicken", "Giant Marsh Frog", "Mouse", "School of Fish", "Snake", "Spider", "Toad"},
["Echo Isles"]={""},
["Felwood"]={"Beetle", "Tainted Cockroach", "Tainted Moth", "Tainted Rat", "Tainted Squirrel"},
["Feralas"]={"Deer", "Rabbit", "Snake"},
["Moonglade"]={"Deer", "Harlequin Frog", "Rabbit"},
["Molten Front"]={"Cinderling"},
["Mount Hyjal"]={"Alpine Chipmunk", "Ash Lizard", "Bat", "Carrion Rat", "Death's Head Cockroach", "Elfin Rabbit", "Fire Beetle", "Fire-Proof Roach", "Forest Moth", "Grotto Vole", "Rabbit", "Rock Viper", "School of Fish", "Silky Moth", "Twilight Beetle"},
["Mulgore"]={"Gazalle", "Hazzranache", "Jazzranache", "Mouse", "Prairie Dog", "Rabbit", "Razzranache", "Spazzranache"},
["Northern Barrens"]={"Adder", "Chicken", "Deer", "Gazelle", "Prairie Dog", "Small Frog", "Swine"},
["Orgrimmar"]={"Dung Beetle", "Moccasin", "Robo-Chick", "Spiny Lizard", "toad", "White Chicken"},
["Shadowglen"]={"Crested Owl"},
["Silithus"]={"Beetle", "Rock Viper", "Scarab Hatchling", "Spiky Lizard"},
["Southern Barrens"]={"Adder", "Dig Rat", "Emerald Boa", "Evervated Adder", "Gazelle", "Prairie Dog", "Small Frog"},
["Stonetalon Mountains"]={"Alpine Chipmunk", "Coral Snake", "Mountain Skunk", "Mouse", "Mule Deer", "Prairie dog,Rabbit", "Raven", "Roach", "School of Fish", "Silithan Hatchling", "Webbed Rabbit"},
["Tanaris"]={"Buzzard", "Desert Spider", "Gold Beetle", "Rattlesnake", "Sand Kitten", "Stinkbug", "Stripe-Tailed Scorpion"},
["Teldrassil"]={"Deer", "Elfin Rabbit", "Red-Tailed Chipmunk", "Small Frog", "Spider", "Toad"},
["The Exodar"]={""},
["The Steam Pools"]={""},
["The Veiled Sea"]={""},
["Thousand Needles"]={"Black Rat", "Roach", "Scorpion"},
["Thunder Bluff"]={""},
["Uldum"]={"Horned Lizard", "Leapard Scorpion", "Locust", "Mac Frog", "Oasis Moth", "Sheep", "Sidewinder"},
["Un'Goro Crater"]={"Ash Lizard", "Beetle", "Cockroach", "Emerald Boa", "Long-tailed Mole", "Parrot", "Spotted Bell Frog", "Tree Python"},
["Valley of Trials"]={"Adder"},
["Winterspring"]={"Alpine Chipmunk", "Alpine Hare", "Crystal Spider", " Lemming", "Mountain Skunk", "Rabbot", "Rabid Nut Varmint 5000", "Robo-Chick", "Spider"},
--Eastern Kingdoms
["Abyssal Breach"]={""},
["Arathi Highlands"]={"Cat", "Cow", "Grasslands Cottontail", "Prairie Dog", "Ram", "Rat", "Small Frog"},
["Badlands"]={"Beetle", "Black Rat", "Gold Beetle", "Spiky Lizard", "Stripe-Tailed Scorpion"},
["Blackrock Mountain"]={"Fire Beetle"},
["Blasted Lands"]={"Adder", "Fire Beetle"},
["Burning Steppes"]={"Ash Viper", "Lava Crab", "Scorpion"},
["Coldridge Valley"]={"Alpine Hare"},
["City of Ironforge"]={""},
["Deadwind Pass"]={""},
["Deathknell"]={"Rat"},
["Deeprun Tram"]={"Deeprun Rat"},
["Dun Morogh"]={"Alpine Hare", "Irradiated Roach", "Rabbit", "Tame Crag Boar"},
["Duskwood"]={"Black Rat", "Chicken", "Dusk Spiderling", "Rabbit", "Rat Snake", "Roach", "Skunk"},
["Eastern Plaguelands"]={"Bat", "Beetle", "Black Rat", "Cockroach", "Infected Deer", "Infected Squirrel", "Scorpion", "Spider"},
["Elwynn Forest"]={"Cat", "Chicken", "Cow", "Deer", "Fawn", "Rabbit", "Sheep", "Small Frog", "Stormwind Rat", "Tekton"},
["Eversong Woods"]={"Cat", "School of Fish"},
["Ghostlands"]={"Larva", "Maggot"},
["Gilneas"]={"Deer", "Gilnean Crow", "Putrescent Maggot", "Rat", "Sheep", "Skunk", "Snake", "Spider", "Toad"},
["Gilneas City"]={"Cat", "Deer", "Frightened Chicken", "Gilnean Crow", "Putrescent Maggot", "Rat", "Roach", "Sheep", "Skunk"},
["Hillsbrad Foothills"]={"Chicken", "Deer", "Huge Toad", "Maggot", "Rabbit", "Ram", "Toad"},
["Ironforge"]={"Long-tailed Mole"},
["Isle of Quel'Danas"]={""},
["Loch Modan"]={"Alpine Hare", "Lil' Sooty", "Ram", "Rat", "Scoot", "Small Frog", "Smokey"},
["New Tinkertown"]={"Alpine Hare", "Irradiated Roach"},
["Northern Stranglethorn"]={"Adder", "Beetle", "Crimson Moth", "Forest Spiderling", "Lizard Hatchling", "Long-tailed Mole", "Moccasin", "Parrot", "Roach", "Shore Crab", "Snake", "Tree Python"},
["Northshire"]={""},
["Plaguelands: The Scarlet Enclave"]={""},
["Redridge Mountains"]={"Chicken", "Cow", "Mountain Cottontail", "Rabbit", "Redridge Rat", "Roach", "Sheep", "Wild Rat"},
["Ruins of Gilneas"]={"Ewe", "Ram", "White Chicken"},
["Searing Gorge"]={"Ash Spiderling", "Fire Beetle", "Lava Crab"},
["Silvermoon City"]={"Rabbit"},
["Silverpine Forest"]={"Corpse-Fed Rat", "Infected Deer", "Infected Squirrel", "Mutant Bush Chicken"},
["Stormwind City"]={"Cow", "Rabbit", "Rat", "Sea Gull", "Squirrel", "Stormwind Rat"},
["Stranglethorn Vale"]={"Adder", "Beetle", "Crimson Moth", "Forest Spiderling", "Lizard Hatchling", "Long-tailed Mole", "Moccasin", "Parrot", "Rat", "Roach", "Shore Crab", "Snake", "Tree Python", "Wharf Rat"},
["Sunstrider Isle"]={""},
["Swamp of Sorrows"]={"Huge Toad", "Moccasin", "Parrot", "Swamp Moth"},
["The Cape of Stranglethorn"]={"Crimson Moth", "Forest Spiderling", "Lizard Hatchling", "Long-tailed Mole", "Parrot", "Rat", "Roach", "Shore Crab", "Tree Python", "Wharf Rat"},
["The Hinterlands"]={"Brown Marmot", "Cockroach", "Deer", "Hare", "Maggot", "Rat", "Spider"},
["The Great Arena"]={""},
["The Temple of Atal'Hakkar"]={""},
["The Great Sea"]={""},
["The Maw of Madness"]={""},
["Tirisfal Glades"]={"Chicken", "Rabbit", "Rat"},
["Twilight Highlands"]={"Black Rat", "Cockroach", "Grizzly Squirrel", "Highlands Clucker", "Highlands Mouse", "Highlands Skunk", "Highlands Turkey", "Huge Toad", "Moccasin", "Rattlesnake", "Scorpion", "Shore Crab", "Twilight Spider", "Yellow-Bellied Marmot"},
["Undercity"]={"Maggot", "Roach", "Undercity Rat"},
["Vashj'ir"]={"Crab Hatchling", "Eel Larva", "Giant Isopod", "Juvenile Coral Crab", "Puffer Hatchling", "Rift Elver", "Rockchewer Whelk", "Sea Cucumber"},
["Abyssal Depths"]={"Crab Hatchling", "Eel Larva", "Giant Isopod", "Rift Elver", "Sea Cucumber"},
["Damplight Chamber"]={""},
["Kelp'thar Forest"]={"Crab Hatchling", "Juvenile Coral Crab", "Puffer Hatchling", "Rift Elver"},
["Shimmering Expanse"]={"Crab Hatchling", "Eel Larva", "Giant Isopod", "Juvenile Coral Crab", "Rift Elver", "Rockchewer Whelk", "Sea Cucumber"},
["Western Plaguelands"]={"Deer", "Rabbit"},
["Westfall"]={"Chicken", "Prairie Dog"},
["Wetlands"]={"Black Rat", "Cockroach", "Moccasin", "Mouse", "Ram"},
--Outland
["Blade's Edge Mountains"]={"Brown Marmot", "Marmot", "Rabbit", "Skittering Cavern Crawler"},
["Hellfire Peninsula"]={"Adder", "Scorpion"},
["Nagrand"]={"Rabbit", "Rat", "Snake"},
["Netherstorm"]={"Spectral Bovine"},
["Shadowmoon Valley"]={""},
["Shattrath City"]={"Ewe"},
["Terokkar Forest"]={"Rat", "Skunk"},
["Twisting Nether"]={""},
["Zangarmarsh"]={"Small Frog", "Snake"},
--Northrend
["Borean Tundra"]={"Arctic Hare", "Borean Frog", "Borean Marmot", "Shore Crab", "Steam Frog", "Tundra Penguin"},
["Crystalsong Forest"]={""},
["Dalaran"]={"Monstrous Underbelly Rat", "Rabbit", "Sewer Frog", "Squirrel", "Underbelly Rat"},
["Dragonblight"]={"Arctic Hare", "Cockroach", "Shore Crab"},
["Grizzly Hills"]={"Fawn", "Flora", "Grizzly Squirrel", "Mountain Skunk", "Rainbow Trout"},
["Howling Fjord"]={"Chicken", "Devouring Maggot", "Fjord Penguin", "Fjord Rat", "Fjord Turkey", "Maggot", "Mesmerized Frog", "Mountain Skunk", "Rabbit", "Rat", "Roach", "Scalawag Frog", "Sheep", "Skunk", "Snake", "Spider", "Turkey"},
["Hrothgar's Landing"]={""},
["Icecrown"]={"Cockroach", "Glacier Penguin"},
["Sholazar Basin"]={"Biletoad", "Chicken Escapee", "Glinting Bug", "Sholazar Tickbird", "Sparkling Hare"},
["The Frozen Sea"]={""},
["The Storm Peaks"]={"Cockroach"},
["Wintergrasp"]={""},
["Zul'Drak"]={"Arctic Hare", "Huge Toad", "Hungry Penguin"},
--The Maelstrom
["Darkmoon Island"]={"Cow", "Moonweb Spider", "Sea Gull"},
["Deepholm"]={"Amethyst Shale Hatchling", "Crimson Shale Hatchling", "Crystal Beetle", "Deepholm Cockroach", "Emerald Shale Hatchling", "Fungal Moth", "Stoaway Rat", "Topaz Shale Hatchling", "Twilight Beetle", "Twilight Spider"},
["Kezan"]={"Atiu", "Avarua", "Black Rat", "Funafuti", "Mata", "Rima", "Roach"},
["The Lost Isles"]={"Crab", "Frog", "Island Turtle", "Rat", "Shore Crab", "Wild Clucker"},
["The Maelstrom"]={""},
["Tol Barad"]={"Bardin Fox Kit", "Prison Rat", "Snake"},
["Tol Barad Peninsula"]={"Darkwood Hatchling", "Sassy Cat", "Squirrel", "Wharf Rat"},
--Pandaria
["Dread Wastes"]={"Amber Moth", "Clouded Hedgehog", "Crunchy Scorpion", "Emperor Crab", "Glinting Rapana Whelk", "Rapana Whelk", "Resilient Roach", "Ringtail Bandit", "Sha-Haunted Rodent"},
["Isle of Giants"]={""},
["Isle of Thunder"]={"Amberglow Firefly", "Ashen Weaver", "Darkeye Raven", "Swamp Hopper", "Venom Skitterer"},
["Krasarang Wilds"]={"Amethyst Spiderling", "Bluescale Cranefish", "Cave Crawler", "Deepflow Carp", "Feverbite Hatchling", "Flailing Carp", "Greenscale Cranefish", "Hippocampus Mysticus", "Hungry Gull", "Hungry Rat", "Krasarang Croaker", "Krasarang Frog", "Krasarang Tideskirter", "Luyu Moth", "Malayan Quillrat", "Mei Li Sparkler", "Redscale Cranefish", "Savory Beetle", "Scrawny Carp", "Shore Crab", "Sifang Otter", "Spiny Terrapin", "Whitescale Cranefish"},
["Kun-Lai Summit"]={"Alpine Foxling", "Alpine Foxling Kit", "Chillwater Carp", "Effervescent Glowfly", "Eternal Strider", "Golden Civet", "Golden Civet Kitten", "Jungle Toad", "Plains Monitor", "Prairie Mouse", "Szechuan Chicken", "Tolai Hare", "Tolai Hare Pup", "Yellow-Bellied Bullfrog", "Zooey Snake"},
["Shrine of Seven Stars"]={"Eternal Strider", "Gilded Moth"},
["Shrine of Two Moons"]={"Eternal Strider", "Gilded Moth"},
["The Jade Forest"]={"Bucktooth Flapper", "Cocky Crow", "Coral Adder", "Emerald Turtle", "Garden Frog", "Garden Moth", "Grove Viper", "Jumping Spider", "Jungle Darter", "Leopard Tree Frog", "Masked Tanuki", "Masked Tanuki Pup", "Mirror Strider", "Painted Carp", "Saltscale Carp", "Sandy Petrel", "Shrine Fly", "Sifang Otter", "Sifang Otter Pup", "Silkbead Snail", "Spirebound Crab", "Temple Snake", "Veridian Carp", "Wild Carp", "Wishing Frog"},
["The Veiled Stair"]={"Bandicoon", "Malayan Quillrat"},
["Townlong Steppes"]={"Amber Moth", "Clouded Hedgehog", "Crunchy Scorpian", "Grassland Hopper", "Mongoose", "Mongoose Pup", "Yakrat"},
["Vale of Eternal Blossoms"]={"Dancing Water Skimmer", "Effervescent Glowfly", "Eternal Strider", "Gilded Moth", "Golden Civet", "Golden Civet Kitten", "Yellow-Bellied Bullfrog"},
["Valley of the Four Winds"]={"Amorous Rooster", "Azure Flutterwing", "Bandicoon", "Bandicoon Kit", "Bucktooth Flapper", "Cocky Crow", "Disguised Marmot", "Emerald Turtle", "Farm Moth", "Glade Glimmer", "Hillpaw's Chicken", "Insect Swarm", "Irdescent Flutterwing", "Lost Hen", "Lumpy Toad", "Malayan Quillrat", "Malayan Quillrat Pup", "Marsh Fiddler", "Pimple", "Plump Marmot", "Rash", "Sifang Otter", "Softshell Snapling", "Sun-Touched Flutterwing", "Wild Silkworm", "Zitz"},
--Arenas
["Blade's Edge Arena"]={""},
["Dalaran Arena"]={""},
["Nagrand Arena"]={""},
["Ruins of Lordaeron"]={""},
["The Ring of Valor"]={""},
["The Tiger's Peak"]={""},
["Tol'viron Arena"]={""},
--Battlegrounds
["[TEMP] JT"]={""},
["Alterac Valley"]={""},
["Arathi Basin"]={""},
--Must be a placeholder
["CTF3"]={""},
["Deepwind Gorge"]={""},
["Eye of the Storm"]={""},
["Isle of Conquest"]={""},
["Silvershard Mines"]={""},
["Strand of the Ancients"]={""},
["Temple of Kotmogu"]={""},
["The Battle for Gilneas"]={""},
["Twin Peaks"]={""},
["Wildhammer Stronghold"]={""},
["Warsong Gulch"]={""},
["Silverwing Hold"]={""},
--Scenarios
["A Brewing Storm"]={""},
["A Little Patience"]={"Oily Serpent", "Volatile Firefly"},
["Arena of Annihilation"]={""},
["Assault on Zan'vess"]={""},
["Battle on the High Seas"]={""},
--Silly Warlocks and their green fire
["Black Temple"]={"Sewer Crocolisk", "Sewer Rat", "Snake", "Spider", "Toad"},
["Blood in the Snow"]={""},
["Brewing Festival"]={""},
["Crypt of Forgotten Kings"]={""},
["Daggar in the Dark"]={"Explosive Sheep"},
["Dark Heart of Pandaria"]={""},
["Domination Point"]={""},
["Dustwallow Marsh"]={""},
["Fall of Shan Bu"]={""},
["Greenstone Village"]={""},
["Infiltrating the Shipyard"]={""},
["Isle of Thunder"]={""},
["Krasarand Wilds"]={"Amethyst Spiderling", "Bluescale Cranefish", "Cave Crawler", "Deepflow Carp", "Feverbite Hatchling", "Flailing Carp", "Greenscale Cranefish", "Hippocampus Mysticus", "Hungry Gull", "Hungry Rat", "Krasarang Croaker", "Krasarang Frog", "Krasarang Tideskirter", "Luyu Moth", "Malayan Quillrat", "Mei Li Sparkler", "Redscale Cranefish", "Savory Beetle", "Scrawny Carp", "Shore Crab", "Sifang Otter", "Spiny Terrapin", "Whitescale Cranefish"},
["Kun-Lai Summit"]={"Alpine Foxling", "Alpine Foxling Kit", "Chillwater Carp", "Effervescent Glowfly", "Eternal Strider", "Golden Civet", "Golden Civet Kitten", "Jungle Toad", "Plains Monitor", "Prairie Mouse", "Szechuan Chicken", "Tolai Hare", "Tolai Hare Pup", "Yellow-Bellied Bullfrog", "Zooey Snake"},
["Lion's Landing"]={""},
["Peak of Serenity"]={""},
["Proving Grounds"]={""},
--Assuming these two are just placeholders
["Scenario - Black Ox Temple"]={""},
["Scenario - Mogu Ruins"]={""},
["Stormsea Landing"]={""},
["The Jade Forest"]={"Bucktooth Flapper", "Cocky Crow", "Coral Adder", "Emerald Turtle", "Garden Frog", "Garden Moth", "Grove Viper", "Jumping Spider", "Jungle Darter", "Leopard Tree Frog", "Masked Tanuki", "Masked Tanuki Pup", "Mirror Strider", "Painted Carp", "Saltscale Carp", "Sandy Petrel", "Shrine Fly", "Sifang Otter", "Sifang Otter Pup", "Silkbead Snail", "Spirebound Crab", "Temple Snake", "Veridian Carp", "Wild Carp", "Wishing Frog"},
["The Secrets of Ragefire"]={""},
["Theramore's Fall"]={""},
["Thunder King's Citadel"]={""},
["To The Skies"]={""},
["Troves of the Thunder King"]={"Ashen Weaver", "Darkeye Raven"},
["Unga Ingoo"]={""},
--Dungeons
--Classic
["Blackfathom Deeps"]={"Beetle", "Shore Crab"},
["Blackrock Depths"]={""},
["Blackrock Spire"]={""},
["Dire Maul"]={"Deer", "Rat", "Roach"},
["Gnomeregan"]={""},
["Maraudon"]={"Amethyst Shale Hatchling", "Rat", "Roach", "School of Fish", "Snake"},
["Ragefire Chasm"]={""},
["Razorfen Downs"]={""},
["Scarlet Monastery"]={"Rabbit"},
["Scholomance"]={"Rat"},
["Shadowfang Keep"]={"Black Rat"},
["Stratholme"]={"Plagued Insect", "Plagued Maggot", "Plagued Rat"},
["Sunken Temple"]={"Rat", "Small Frog", "Snake", "Spider"},
["The Deadmines"]={"Mine Rat", "Rat"},
["Uldaman"]={""},
["Wailing Caverns"]={"Biletoad", "Snake"},
["Zul'Farrak"]={""},
--Outland
["Auchenai Crypts"]={"Spider"},
["Mana-Tombs"]={"Adder", "Rat", "Roach", "Spider"},
["Sethekk Halls"]={"Adder", "Rat", "Roach", "Snake", "Spider"},
["Shadow Labyrinth"]={"Spider"},
["Caverns of Time"]={""},
["Old Hillsbrad Foothills"]={"Captured Critter", "Reanimated Critter"},
["The Black Morass"]={"Snake"},
["The Slave Pens"]={"Adder", "Black Rat", "Small Frog"},
["The Steamvault"]={"Shore Crab", "Small Frog", "Snake", "Toad"},
["The Underbog"]={"Adder", "Maggot", "Toad"},
["Hellfire Ramparts"]={""},
["The Blood Furnace"]={""},
["The Shattered Halls"]={"Black Rat", "Fire Beetle", "Rat", "Snake"},
["Magisters' Terrace"]={"Squirrel"},
["The Arcatraz"]={""},
["The Botanica"]={""},
["The Mechanar"]={""},
--Northrend
["Ahn'kahet: The Old Kingdom"]={"Roach", "Spider"},
["Azjol-Nerub"]={"Roach"},
["The Culling of Stratholme"]={""},
["Trial of the Champion"]={""},
["Drak'Tharon Keep"]={"Spider"},
["Halls of Reflection"]={""},
["Pit of Saron"]={"Spider"},
["The Forge of Souls"]={""},
["The Nexus"]={"Crystal Spider"},
["The Oculus"]={""},
["The Violet Hold"]={""},
["Halls of Lightning"]={""},
["Halls of Stone"]={"Gold Beetle"},
["Utgarde Keep"]={"Beetle", "Black Rat"},
["Utgarde Pinnacle"]={"Beetle", "Black Rat", "Spider"},
--Cataclysm
["Throne of Tides"]={""},
["Blackrock Caverns"]={""},
["End Time"]={""},
["Grim Batol"]={""},
["Halls of Origination"]={"Beetle"},
["Hour of Twilight"]={""},
["Lost City of the Tol'vir"]={"Beetle", "Desert Spider", "Dung Beetle", "Emerald Boa", "Horned Lizard", "Oasis Moth", "Snake"},
["The Stonecore"]={"Crimson Shale Hatchling", "Emerald Shale Hatchling", "Topaz Shale Hatchling"},
["The Vortex Pinnacle"]={""},
["Well of Eternity"]={""},
["Zul'Gurub"]={""},
--Pandaria
["Gate of the Setting Sun"]={""},
["Mogu'shan Palace"]={""},
["Scarlet Halls"]={""},
["Scarlet Monastery"]={""},
["Scholomance"]={""},
["Shado-Pan Monastery"]={""},
["Siege of Niuzao Temple"]={""},
["Stormstout Brewery"]={""},
["Temple of the Jade Serpent"]={""},
--Raids
--Classic
["Blackwing Lair"]={""},
["The Molten Core"]={""},
["Ruins of Ahn'Qiraj"]={""},
["Temple of Ahn'Qiraj"]={""},
["Ahn'Qiraj"]={""},
--Outland
["Black Temple"]={"Sewer Crocolisk", "Sewer Rat", "Snake", "Spider", "Toad"},
["Hyjal Summit"]={""},
["Serpentshrine Cavern"]={""},
["Gruul's Lair"]={""},
["Magtheridon's Lair"]={""},
["Karazhan"]={"Rat", "Spider"},
["Sunwell Plateau"]={""},
["The Eye"]={""},
["Tempest Keep"]={""},
["Zul'Aman"]={"Spider", "Squirrel"},
--Northrend
["Trial of the Crusader"]={"Frost Sphere"},
["Icecrown Citadel"]={"Black Rat", "Blood Parasite", "Blood Spider", "Frozen Insect", "Plagued Insect", "Roach", "Spider"},
["Naxxramas"]={"Larva", "Maggot", "Mr. Bigglesworth"},
["Onyxia's Lair"]={""},
["The Eye of Eternity"]={""},
["Ulduar"]={""},
["Vault of Archavon"]={""},
["The Obsidian Sanctum"]={""},
["The Ruby Sanctum"]={""},
--Cataclysm
["Baradin Hold"]={""},
["The Dragon Wastes"]={""},
["Blackwing Descent"]={""},
["Dragon Soul"]={""},
["The Bastion of Twilight"]={""},
["Throne of the Four Winds"]={""},
["Firelands"]={"Ashtongue Adder, Cinderslither Snake, Kindleworm, Magamaspray Beetle"},
--Pandaria
["Heart of Fear"]={""},
["Mogu'shan Vaults"]={""},
["Terrace of Endless Spring"]={""},
["Throne of Thunder"]={""}}
 
-- local MACRO_ICON_NAME = "Ability_Hunter_RunningShot.blp"
-- local MACRO_ICON_INDEX = 1

-- local i = 1
-- while i <= 1000 do
	-- local iconName = GetSpellorMacroIconInfo(i)
	-- if iconName == MACRO_ICON_NAME then
		-- MACRO_ICON_INDEX = i
		-- break
	-- end
	-- i = i + 1
-- end

function SmartCritterKiller_OnLoad()

	SmartCritterKiller:RegisterEvent("ZONE_CHANGED_NEW_AREA");
    SmartCritterKiller:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    SmartCritterKiller:RegisterEvent("VARIABLES_LOADED");    
    SmartCritterKiller:RegisterEvent("PLAYER_TARGET_CHANGED");
    
end

-- function MakeMacro()
		-- macroId = CreateMacro("!TargetCritters", 20, "/startattack", nil, 1);
	-- end

function MakeMacro()
		macroId = CreateMacro("!TargetCritters", SCK_icon, "/startattack", nil, 1);
	end
--slash command to make a macro
local SmartCritterKiller = {};
-- function SmartCritterKiller.SlashCommand()
	-- call = MakeMacro()
-- end

	--code reused from the addon Critters by Weeperman
function SmartCritterKiller_OnEvent(self, event, ...)
	if not IsInGuild() then return end
	local _, type, _, Playername, _, _, destCritter, _ = select(1, ...)
	if macroId ~= nil then
		if event == "ZONE_CHANGED_NEW_AREA" then
			if SCK_zonespam == "on" then 
				print("Zone changed, macro updated.")
			end
			local a = ""
			local b = GetRealZoneText()
				for i = 1, getn(Critters[b]) do
					a = a.. "/tar "..Critters[b][i].."\n"
				end
				EditMacro("!TargetCritters", "!TargetCritters", SCK_icon, a.."/startattack", nil, 1);
			end
		end

local  timestamp, type, hideCaster, sourceGUID, Playername, sourceFlags, _, destGUID, destCritter, destFlags = select(1, ...)         

	if (event=="COMBAT_LOG_EVENT_UNFILTERED") then             
        if (type == "PARTY_KILL") then 
            if (Playername == UnitName("player") and destGUID ~= nil) then
			    if ((tContains( Critters, destCritter )) or (tContains(UnknownCritz,destCritter)) ) then
                --if ((tContains( Critters, destCritter )) ) then
                   _ , _, _, quantity, reqQuantity, _, _, _, _, _=  GetAchievementCriteriaInfo(critterTrackId, GetAchievementNumCriteria(critterTrackId));

                    -- another critter killed
                    IndivCritzKilled = IndivCritzKilled + 1
                    
                    if (quantity > 0 ) then
                        local LeftToKill = reqQuantity-quantity;
                        if LeftToKill > 0 then    
						--Critter name in yellow, number in red
                            local message = string.format("A|cffffff00 %s|r died, only|cffff0000 %d|r critters to go.",destCritter,LeftToKill);         
							local guildmessage = string.format("A %s died, only %d critters to go.",destCritter,LeftToKill);
                            if ((IndivCritzKilled % ReportFrequency == 0) and (PingGuild == true) and (SCK_guildspam == "on")) then
							--if ((IndivCritzKilled % ReportFrequency == 0) and (SCK_guildspam == true)) then
                                -- only update the guild when required
                                SendChatMessage(guildmessage ,"GUILD");
                            else
								if SCK_selfspam == "on" then
                                DEFAULT_CHAT_FRAME:AddMessage(string.format("%s You killed|cff00ff00 %d|r of them!",message,IndivCritzKilled));
								end
                            end 
                        else
                            DEFAULT_CHAT_FRAME:AddMessage("Another Critter died, no more please - make the madness stop.");
                        end
                    end                                        
                end
            end        
        end
    elseif(event == "VARIABLES_LOADED") then
        --sort out the initialisation
        if UnknownCritz== nil then
            UnknownCritz = {}
        else
            if (table.getn(UnknownCritz) > 0) then
                DEFAULT_CHAT_FRAME:AddMessage(string.format("Did you know that you have %d critters in your local database, please help update the master database by sending your 'WTF\Account\<Account name>\SavedVariables\SmartCritterKiller.lua' file to hyper_dude_256@yahoo.com",table.getn(UnknownCritz)));
            end
        end    
        if ReportFrequency == nil then
            ReportFrequency = defaultReportFrequency;
        end
        
        if PingGuild == nil then
            PingGuild = true -- suitable default
        end        
        
        if IndivCritzKilled == nil then
            IndivCritzKilled = 0 -- suitable default
        end
        
        -- toggle the tracked achievement to reset the values 
        AddTrackedAchievement(critterTrackId);
       -- RemoveTrackedAchievement(critterTrackId);
                
        _ , _, _, quantity, reqQuantity, _, _, _, _, _=  GetAchievementCriteriaInfo(critterTrackId, GetAchievementNumCriteria(critterTrackId)); 
        _, Name, _, _, _, _, _, _, _, _ = GetAchievementInfo(critterTrackId)
        local LeftToKill = reqQuantity-quantity;
        
        if LeftToKill > 0 then
            DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffSmartCritterKiller|cffff9900 %s|cffffffff loaded. We still need %d for %s", version, LeftToKill,Name))  
        else
            DEFAULT_CHAT_FRAME:AddMessage(string.format("|cffffffffSmartCritterKiller|cffff9900 %s|cffffffff loaded. Your guild is the '%s'", version, Name))  
        end 
        
    elseif( event == "PLAYER_TARGET_CHANGED" ) then
    --check for any critters we dont have on our database
		local name = UnitName("target")
		local creatureType = UnitCreatureType("target")
		if creatureType == L_CRITTER then
            if (not (tContains( Critters, name)) and not (tContains( UnknownCritz, name))) then           
                table.insert(UnknownCritz,name);
               -- DEFAULT_CHAT_FRAME:AddMessage(string.format("Added %s to the list of unknown critters",name));
            end
        end    
    end
end

SLASH_SmartCritterKiller_Slash_Command1 = "/smartcritterkiller";
SLASH_SmartCritterKiller_Slash_Command2 = "/sck";

-- SlashCmdList.SmartCritterKiller = function(input) -- input contains the string after /sck
	-- icon = input -- Assign the string to icon
-- end


function handler(msg, editBox)
    local command, rest, option = msg:match("^(%S*)%s*(%S*)%s*(.-)$")
    -- Any leading non-whitespace is captured into command
    -- the rest (minus leading whitespace) is captured into rest.
    if command == "create" then
        call = MakeMacro()
		print("Macro created, go kill some critters!")		-- Handle adding of the contents of rest... to something.
    elseif command == "icon" and rest ~= "" then
        SCK_icon = rest 
		print("Icon set to "..rest)-- Handle removing of the contents of rest... to something. 
	elseif command == "report" and rest ~= "" then
		newReport = tonumber(rest)
		ReportFrequency = newReport
			if not newReport or newReport <= 0 or floor(newReport) ~= newReport then
				ReportFrequency = defaultReportFrequency
				print("Invalid number, reporting after |cffff0000"..defaultReportFrequency.."|r critters")
			else
				print("Now reporting to guild after |cff00ff00"..ReportFrequency.."|r critters")
			end
		elseif command == "ann" and rest ~= "" then
			if rest == "guild" then
				if option == "on" then
					SCK_guildspam = "on"
					print("Reporting to the guild is |cff00ff00ON|r.")
				elseif option == "off" then
					SCK_guildspam = "off"
					print("Reporting to the guild is |cffff0000OFF|r.")
				else
					print("Invalid selection, guild reporting is unchanged.")
				end
			elseif rest == "self" then
				if option == "on" then
					SCK_selfspam = "on"
					print("Reporting to yourself is |cff00ff00ON|r.")
				elseif option == "off" then
					SCK_selfspam = "false"
					print("Reporting to yourself is |cffff0000OFF|r.")
				else
					print("Invalid selection, self reporting is unchanged.")
				end
			elseif rest == "zone" then
				if option == "on" then
					SCK_zonespam = "on"
					print("Reporting on zonechange is |cff00ff00ON|r.")
				elseif option == "off" then
					SCK_zonespam = "off"
					print("Reporting on zonechange is |cffff0000OFF|r.")
				else
					print("Invalid selection, zone reporting is unchanged.")
				end
			elseif rest == "all" then
				if option == "on" then
					SCK_guildspam = "on"
					SCK_selfspam = "on"
					SCK_zonespam = "on"
					print("Reporting to the guild, yourself, and on zone change is |cff00ff00ON|r.")
				elseif option == "off" then
					SCK_guildspam = "off"
					SCK_selfspam = "off"
					SCK_zonespam = "off"
					print("Reporting to the guild, yourself, and on zone change is |cffff0000OFF|r.")
				else
					print("Invalid selection, reporting is unchanged.")
				end
			else print("Invalid selection: ann (guild|self|zone) (on|off)")
		end
    else
        -- If not handled above, display some sort of help message
        print("|cffe5cc80S|r|cffa335eemart|r|cffe5cc80C|r|cffa335eeritter|r|cffe5cc80K|r|cffa335eeiller|r Help")
		print("/|cffe5cc80sck|r |cffaaff00create|r : Makes a new crittercidle macro.")
		print("/|cffe5cc80sck|r |cffaaff00icon|r |cff0070dd button_name |r : Sets the macro icon to button_name.")
		print("/|cffe5cc80sck|r |cffaaff00report|r |cff0070dd number |r : Changes reporting to the guild to number.")
		print("/|cffe5cc80sck|r |cffaaff00ann|r (guild|self|zone|all)|cff0070dd (on|off) |r : Turns reporting on or off.")
    end
end

SlashCmdList["SmartCritterKiller_Slash_Command"] = handler;
